%define debug_package %{nil}

# Note that this is NOT a relocatable package
%define ver      1.3.0
%define rel      1%{?dist}
%define prefix   /usr

Summary:	Network traffic recorder
Name:		tcpflow
Version:	%ver
Release:	%rel
License:	GPLv3
Group:		Console/Networking
Source:		ftp://ftp.circlemud.org/pub/jelson/tcpflow/%{name}-%{version}.tar.gz
Patch0:               %{name}-%{version}-patch-001
BuildRoot:	/var/tmp/tcpflow-root
Prefix:		%prefix
URL:		http://www.circlemud.org/~jelson/software/tcpflow/
BuildRequires:	libpcap-devel
Requires:	libpcap

%description
tcpflow is a program that captures data transmitted as part of TCP
connections (flows), and stores the data in a way that is convenient for
protocol analysis or debugging. A program like 'tcpdump' shows a summary
of packets seen on the wire, but usually doesn't store the data that's
actually being transmitted. In contrast, tcpflow reconstructs the actual
data streams and stores each flow in a separate file for later analysis.

%prep
%setup
%patch0 -p1

%build
# Needed for snapshot releases.
%ifarch alpha
  MYARCH_FLAGS="--host=alpha-redhat-linux"
%endif
MYCFLAGS="$RPM_OPT_FLAGS"

#if [ ! -f configure ]; then
#  CFLAGS="$MYCFLAGS" ./autogen.sh $MYARCH_FLAGS --prefix=%prefix --localstatedir=/var/lib --with-pcap=/usr/include/pcap
#else
#  CFLAGS="$MYCFLAGS" ./configure $MYARCH_FLAGS --prefix=%prefix --localstatedir=/var/lib --with-pcap=/usr/include/pcap
#fi

CFLAGS="$MYCFLAGS" ./configure $MYARCH_FLAGS --prefix=%prefix --localstatedir=/var/lib 

if [ "$SMP" != "" ]; then
  (make "MAKE=make -k -j $SMP"; exit 0)
  make
else
  make
fi

%install
rm -rf $RPM_BUILD_ROOT

make prefix=$RPM_BUILD_ROOT%{prefix} install

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-, root, root)

%doc AUTHORS COPYING ChangeLog NEWS README
%{_bindir}/*
%{_mandir}/man*/*

%changelog
* Mon Aug 20 2012 Simson Garfinkel <simsong@alphonse-mucha.home> 1.3.0-1
* Release 1.3.0-1
	* src/tcpdemux.cpp (tcpdemux::process_tcp): fixed bug in which myflow.tlast wasn't being set.

* Thu Aug 16 2012 Simson Garfinkel <simsong@alphonse-mucha.home> 1.2.9-1
* Release 1.2.9-1
	* src/main.cpp (main): fixed compile bugs that resulted from adoption of standard DFXML header.
        * configure.ac (HAVE_PTHREAD): fixed typo in configure.ac
        * src/tcpdemux.h: removed struct ip as it was redundent to struct iphdr
        * configure.ac: tcpflow now compiles under mingw for Windows
        * src/tcpdemux.cpp: moved tcpdemux class methods into this new file.
        * src/tcpip.cpp (tcpip::close_file): added support for FUTIMENS, but I don't yet have a system on which to test it. Hope that it's good.

* Mon Jul 23 2012 Simson Garfinkel <simsong@alphonse-mucha.home> 1.2.8-1
* Release 1.2.8-1
	* src/main.cpp (main): added calling process_infile(expression,device,"",true) when no files are provided to fix bug of no live capture.
	* src/sysdep.h: removed; put code in tcpflow.h for simplicity
	* src/datalink.cpp (dl_null): moved ETHERTYPE_IPV6 from sysdep.h to datalink.cpp 
	* bootstrap.sh: added --add-missing to bootstrap.sh

* Thu May 24 2012 Simson Garfinkel  <simsong@alphonse-mucha.home> 1.2.7-1
* Release 1.2.7-1
	* src/main.cpp (main):  -r option now allows for multiple files to be specified.
	* src/main.cpp (main):  -R option now allows for incomplete tcp connections to be finished.
	* src/main.cpp (main): removed global "tcpdemux demux" variable. Now it's passed as *user in the datalink methods, as it
	  should be.
	* src/tcpdemux.h (class tcpip): bytes_printed renamed to bytes_processed, as it will be used in packet processing as well.

* Thu Apr 19 2012 Simson Garfinkel  <simsong@alphonse-mucha.home> 1.2.6-1
* Release 1.2.6-1
	* configure.ac: incremented version to 1.2.6 (1.2.5 had a bad tag)
	* src/tcpip.cpp (tcpip::print_packet): fixed error in fwrite().
	* src/main.cpp (print_usage): fixed misspelling of name
	* src/tcpip.cpp (tcpdemux::tcpdemux): default outdir is now "."

* Mon Mar 26 2012 Simson Garfinkel  <simsong@alphonse-mucha.home> 1.2.3-1
* Release 1.2.3-1
	* src/xml.cpp (xml::add_cpuid): better handling of CPUID instruction. Now it really should not show up on non-Intel architectures.
	* src/xml.cpp: added unistd.h
	* src/main.cpp (main): added printing stats for debug level 3.
	* src/datalink.cpp (find_handler): changed 'looking for handler' to debug level 2.
	* src/tcpip.cpp (tcpdemux::close_all): Jeremey's FD ring has been replaced with an unordere dset.
	* src/tcpdemux.h (class tcpdemux): tcpdemux is now a class. By 1.3 it will be a linkable class separate from this program.
	* configure.ac: added -funit-at-a-time 
	* COPYING: updated to GPLv3
	* src/xml.cpp (xml::xmlout): writing with size-length tag just outputs the value now.

* Sun Mar 3 2012 Simson Garfinkel  <simsong@alphonse-mucha.home> 1.2.1-1
* Release 1.2.1-1
	* Bug fixes and performances improvements

* Sun Jan 29 2012 Simson Garfinkel  <simsong@alphonse-mucha.home> 1.1.0-1
* Release 1.1.0-1
	* C++ rewrite
	* improved performance
	* DFXML output

* Sun Dec 4 2011 Simson Garfinkel  <simsong@alphonse-mucha.home> 1.0.6-1
* Release 1.0.6-1
	* src/tcpflow.h (flow_state_struct): added bytes_printed counter
	* src/tcpip.c (print_packet): modified to respect bytes_per_flow
	* src/main.c (main): removed prepending of (ip or ip6 or vlan) from user expressions. We now just use what the user provided.
	* src/flow.c (open_file): replaced FGETPOS(flow_state->fp, &(flow_state->pos)) with ftell()
	* src/tcpip.c (store_packet): FSETPOS replaced with fseek (it's better now than in 1999)
	* src/util.c: applied ipv6 patches
	* src/tcpip.c: applied ipv6 patches
	* src/tcpflow.h: applied ipv6 patches
	* src/sysdep.h: applied ipv6 patches
	* src/main.c: applied ipv6 patches
	* src/datalink.c: applied ipv6 patches
	* configure.ac: applied ipv6 patches.
	* src/sysdep.h: removed standards.h and added sys/cdefs.h.
	* Makefile.am (EXTRA_DIST): added TODO.txt
	* doc/tcpflow.1.in: updated doc to reflect new author and distribution point.
	* src/main.c (print_usage): removed  "by Jeremy Elson <jelson@circlemud.org>" from usage.
	* src/util.c (flow_filename): vlan changed from [42] to --42 to avoid some shell issues.
	* Applied debian patch 20_fix-usage, which fixed the usage statement.
	* manually applied debian patch 10_extra-opts, which improves color rendering and passes the state structure, rather than forcing it to be re-calculated.
